/*
 * Copyright (c) 1994,1995 Noriyuki Shiota.  All rights reserved.
 *
 * $Id: html1.c,v 1.7 1997/05/23 16:08:24 root Exp $
 */
#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#include "format.h"
#include "ebs.h"

/*
 * 0x1f 0xNN 楳ޥɤθ˲ХȤΥǡ³ơ֥
 */
u_char	ctlskip[256] = {
    /*  0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f   	*/
	0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0,	/* 0x00 */
	0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0x10 */
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0x20 */
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0x30 */
	0, 2, 0, 0,10, 2, 0, 0,10, 0, 0, 0, 0, 0, 0, 0,	/* 0x40 */
	0, 0, 6, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0x50 */
	0, 0, 6, 6, 6, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0x60 */
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0x70 */
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0x80 */
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0x90 */
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0xa0 */
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0xb0 */
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0xc0 */
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0xd0 */
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0xe0 */
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 0xf0 */
};

/* #define	IMAGE_FORMAT	"xbm" */
#define	IMAGE_FORMAT	"gif"

#define	HGAIJI	0x10000
#define	FGAIJI	0x20000

#define	KEYLEN		2048
u_long	keybuf[KEYLEN + 1];
int	keyind;

#define	TMPSIZE	4096
u_char	sbuf[TMPSIZE];

#define	DISPLENGTH	2048	/* 1ڡɽʸ̤Ƿޤ */

#define	MAXCOUNT	40	/* 1ԤĹ(ʸ) */
int	column;

/*
 *   ʸhtmlǽϤ
 */
put_honmon(inp, cmdp, tp, endcode, lfskip)
	FILE	*inp;
	struct	command *cmdp;
	struct	toc *tp;
{
	int	i, j, c, c0;
	u_char	hi, lo;
	int	in_ref, half, tab = 1;
	int	width, height, count;
	long	pg, off, epg, eoff;
	u_char	*sp;
	struct dict *dt = tp->tc_dict;
	char	*cpath = current_path(cmdp);

	in_ref = half = 0;
	keyind = 0;
	width = height = -1;
	count = 0;
	column = 0;

	/*
	 *   lfskip ǻꤵ줿 LF (0x1f 0x0a) 򥹥åפ
	 *   Фǡɽ뤿˻Ѥ
	 */
	GETW(c, inp);
	for (i = 0; i < lfskip; i++) {
		while (c != M_LF) {
			if ((c >> 8) == H_CONTROL) {
				j = ctlskip[c & 0xff];
				for (; j > 0; j--)
					getc(inp);
			}
			GETW(c, inp);
		}
		GETW(c, inp);
	}
	/*
	 *   tab ޤ doc start ޤǥå
	 */
	while (c == M_TAB || c == M_DOC_START) {
		if (c == M_TAB)
			GETW(tab, inp);
		GETW(c, inp);
	}

	for (; c != M_DOC_END && c != endcode; GETW(c, inp)) {
again:
		count++;
		column++;
		hi = (c >> 8);
		lo = c & 0xff;
		if (hi != H_CONTROL) {
			/*
			 *   楳ɤǤʤν
			 */
			if (in_ref == 0) {
				/*
				 *   ѤΥǤʤ硢ʸȤƽ
				 */
				sp = sbuf;
				if (half == 0) {
					/* ʸξ */
					if (c >= dt->dt_gfbase) {
						/*
						 *  ξinline image
						 *  Ȥhtml
						 */
						putgaiji(cmdp, sp, c, 1);
						eprintf(cmdp, "%s", sbuf);
						continue;
					}
					/*
					 * 0x80  0x83 ޤޤƤ뤳Ȥ
					 * 뤬̣ʤᲿ
					 * ʤ褦ˤƤ롣
					 */
					if ((hi & 0x80) == 0x80)
						continue;
					/* ̾ʸν */
					*sp++ = hi | 0x80;
					*sp++ = lo | 0x80;
					*sp = 0;
					eprintf(cmdp, "%s", sbuf);
					if (column > MAXCOUNT) {
						/*
						 *  MAXCOUNTʸϤ
						 *  (ˡϤ褯ʤ)
						 */
						eprintf(cmdp, "\n");
						column = 0;
					}
					continue;
				}
				/* Ⱦʸξ */
				if (c >= dt->dt_ghbase) {
					/*
					 *  ξinline image򻲾Ȥ
					 *  html
					 */
					putgaiji(cmdp, sp, c, 0);
					eprintf(cmdp, "%s", sbuf);
					continue;
				}
				/*
				 * 0x80  0x83 ޤޤƤ뤳Ȥ
				 * 뤬̣ʤᲿ
				 * ʤ褦ˤƤ롣
				 */
				if ((hi & 0x80) == 0x80)
					continue;
				if ((c0 = zen2han(hi, lo)) != -1) {
					/*
					 * Ѵʤ
					 */
					if (c0 == ' ') {
						/*
						 * ǤʸMAXCOUNT
						 * ۤƤԤ
						 */
						if (column > MAXCOUNT) {
							eprintf(cmdp, "\n");
							column = 0;
						}
					}
					if (c0 > 0x80)
						/*
						 *  ȾѥʤȤƽ
						 *  (ȤϤʤϤ)
						 */
						*sp++ = 0x8e;
					*sp++ = c0;
				}
				else {
					/*
					 * ʸǽ
					 */
					if (column > MAXCOUNT) {
						/*
						 *  MAXCOUNTʸϤ
						 *  (ˡϤ褯ʤ)
						 */
						eprintf(cmdp, "\n");
						column = 0;
					}
					*sp++ = hi | 0x80;
					*sp++ = lo | 0x80;
				}
				*sp = 0;
				eprintf(cmdp, "%s", sbuf);
				continue;
			}
			/*
			 *   ѤΥξ硢ʸkeybuf¸
			 */
			if (keyind >= KEYLEN)
				continue;
			if (half) {
				if (c >= dt->dt_ghbase)
					keybuf[keyind] = c | HGAIJI;
				else if ((c0 = zen2han(hi, lo)) != -1) {
					keybuf[keyind] = c0;
					if (c0 > 0x80)
						keybuf[keyind] |= 0x8e00;
				}
				else
					keybuf[keyind] = c | 0x8080;
			}
			else {
				if (c >= dt->dt_gfbase)
					keybuf[keyind] = c | FGAIJI;
				else
					keybuf[keyind] = c | 0x8080;
			}
			keyind++;
			continue;
		}
		/*
		 *   楳ɤξν
		 */
		switch (lo) {
		case L_DOC_END:			/* 0x03 */
			goto quit;
		case L_UNKNOWN_14:	/* 0x14    k_ewp - cddf:202 */
			GETW(c, inp);	/*		1e01 */
			GETW(c, inp);	/*		1e35 */
			break;
		case L_UNKNOWN_15:		/* 0x15 */
			break;
		case L_HALF_START:		/* 0x04 */
			half = 1;
			break;
		case L_HALF_END:		/* 0x05 */
			half = 0;
			break;
		case L_TAB:			/* 0x09 */
			GETW(c, inp);
#if 1
			if (c == 1) {
#else
			if (tab > 0 && tab == c) {
#endif
				if (cmdp->dispitem || count > DISPLENGTH)
					goto quit;
				eprintf(cmdp, "<p>\n");
				column = 0;
			}
			break;
		case L_LF:			/* 0x0a */
			eprintf(cmdp, "<br>\n");
			column = 0;
			break;
		case L_SUPER_START:		/* 0x0e */
			eprintf(cmdp, "<sup>");
			break;
		case L_SUPER_END:		/* 0x0f */
			eprintf(cmdp, "</sup>");
			break;
		case L_NOLF_START:		/* 0x10 */
			break;
		case L_NOLF_END:		/* 0x11 */
			break;
		case L_KEY_START:		/* 0x41 */
			GETW(c, inp);
			eprintf(cmdp, "<u>");
			break;
		case L_KEY_END:			/* 0x61 */
			eprintf(cmdp, "</u>");
			break;
		case L_REF_START:		/* 0x42 */
		case L_REFMENU_START:		/* 0x43 */
			in_ref = 1;
			keyind = 0;
			break;
		case L_REF_END:			/* 0x62 */
		case L_REFMENU_END:		/* 0x63 */
			if (in_ref == 0 || keyind == 0)
				break;
			in_ref = 0;
			pg = getbcd(inp, 4);
			off = getbcd(inp, 2);
			keybuf[keyind] = 0;
			if (pg == 0 && off == 0) {
				putkeybuf(cmdp, keybuf);
				keyind = 0;
				break;
			}
			eprintf(cmdp, "<a\nhref=\"%s?path=%s",
				cmdp->url, cpath);
			eprintf(cmdp, "%x:%x%s\"\n><u>", pg, off, envstr(cmdp));
			putkeybuf(cmdp, keybuf);
			eprintf(cmdp, "</a></u>\n");
			keyind = 0;
			column = 0;
			break;
		case L_FIGIND_START:		/* 0x45 */
			GETW(c, inp);
			break;
		case L_FIGIND_MID:		/* 0x32 */
			break;
		case L_FIGIND_END:		/* 0x52 */
			pg = getbcd(inp, 4);
			off = getbcd(inp, 2);
			if (pg == 0 && off == 0)
				break;
			eprintf(cmdp, "<br>\n");
			eputfig(cmdp, pg, off);
			eprintf(cmdp, "<br>\n");
			column = 0;
			break;
		case L_FIGREF_KEY:		/* 0x44 */
			eprintf(cmdp, "<p>\n");
			GETW(c, inp);
			height = getbcd(inp, 4);
			width = getbcd(inp, 4);
			break;
		case L_FIGREF_POS:		/* 0x64 */
			pg = getbcd(inp, 4);
			off = getbcd(inp, 2);
			if (width == -1 || height == -1)
				break;
			if (pg == 0 && off == 0)
				break;
			eprintf(cmdp, "<br>\n");
			eputfig1(cmdp, pg, off, width, height);
			eprintf(cmdp, "<br>\n");
			width = height = -1;
			column = 0;
			break;
		case L_REFSND_START:		/* 0x33 */
			in_ref = 1;
			keyind = 0;
			break;
		case L_REFSND_END:		/* 0x53 */
			pg = getbcd(inp, 4);
			off = getbcd(inp, 4);
			if (in_ref == 0 || keyind == 0)
				break;
			keybuf[keyind] = 0;
			if (pg == 0 && off == 0) {
				putkeybuf(cmdp, keybuf);
				in_ref = keyind = 0;
				break;
			}
			eputsnd(cmdp, pg, off);
			eprintf(cmdp, "<u>\n");
			putkeybuf(cmdp, keybuf);
			eprintf(cmdp, "</u></a>\n");
			in_ref = keyind = 0;
			column = 0;
			break;
		case L_REFSND1_START:		/* 0x48 */
			pg = getbcd(inp, 6);
			off = getbcd(inp, 4);
			break;
		case L_REFSND1_END:		/* 0x68 */
			break;
		case L_COLOR_KEY:
			in_ref = 1;
			keyind = 0;
			break;
		case L_COLOR_YOMI:		/* 0x06 */
			keybuf[keyind++] = '(';
			break;
		case L_COLOR_YOMIE:		/* 0x07 */
			keybuf[keyind++] = ')';
			break;
		case L_COLOR_VAL:		/* 0x67 */
			GETW(pg, inp);
			GETW(off, inp);
			if (in_ref == 0 || keyind == 0)
				break;
			keybuf[keyind] = 0;
			if ((off & 0xff00) == 0x1e00)
				eputcolor(cmdp, pg, off);
			else
				eputcolor(cmdp, pg, 0);
			eprintf(cmdp, "<u>\n");
			putkeybuf(cmdp, keybuf);
			eprintf(cmdp, "</u></a>\n");
			in_ref = keyind = 0;
			column = 0;
			if ((off & 0xff00) != 0x1e00) {
				c = off;
				goto again;
			}
			break;
		case L_PCMSND_START:		/* 0x4a */
			GETW(c, inp);	/* ??? 0001 */
			GETW(c, inp);	/* ??? 0112 */
			pg = getbcd(inp, 4);
			off = getbcd(inp, 2);
			epg = getbcd(inp, 4);
			eoff = getbcd(inp, 2);
			in_ref = 1;
			keyind = 0;
			break;
		case L_PCMSND_END:		/* 0x6a */
			if (in_ref == 0)
				break;
			eputpcmsnd(cmdp, pg, off, epg, eoff);
			keybuf[keyind] = 0;
			if (keyind > 0)
				putkeybuf(cmdp, keybuf);
			eprintf(cmdp, "</a>\n");
			in_ref = keyind = 0;
			column = 0;
			break;
		case L_BMPFIG_START:		/* 0x4d */
			GETW(c, inp);	/* ??? 0009 */
			for (i = 0; i < 5; i++)
				GETW(c, inp);	/* ??? 0000 */
			pg = getbcd(inp, 4);
			off = getbcd(inp, 2);
			in_ref = 1;
			keyind = 0;
			break;
			break;
		case L_BMPFIG_END:		/* 0x6d */
			if (in_ref == 0)
				break;
			keybuf[keyind] = 0;
			if (keyind > 0) {
				putkeybuf(cmdp, keybuf);
				eprintf(cmdp, "<br>\n");
			}
			eputbmpfig(cmdp, pg, off);
			eprintf(cmdp, "<br>\n");
			in_ref = keyind = 0;
			column = 0;
			break;
			break;
		case L_DOC_START:		/* 0x02 */
			break;
		default:
			break;
		}
	}
 quit:
	return c;
}

/*
 *   html header ν
 */
put_header(inp, cmdp, tp)
	FILE	*inp;
	struct	command *cmdp;
	struct	toc *tp;
{
	eprintf(cmdp, "Content-Type: text/html\n\n<HTML><HEAD><TITLE>ţ£ף - ʸ</TITLE></HEAD>\n\n<BODY>\n");
}

/*
 *    html footer ν
 */
put_footer(inp, cmdp, tp, eof, offset)
	FILE	*inp;
	struct	command *cmdp;
	struct	toc *tp;
{
	int	pg, off;

	eprintf(cmdp, "<HR><UL>\n");
	if (eof == 0) {
		pg = offset / FRAMESIZE + 1;
		off = offset % FRAMESIZE;
		eprintf(cmdp,
			"<LI><U><A HREF=\"%s?path=%s%x:%x%s\">Υڡ</A></U>\n",
			cmdp->url, current_path(cmdp), pg, off, envstr(cmdp));
	}
	eprintf(cmdp, "<LI><U><A HREF=\"%s?path=%s%s\">˥塼</A></U>\n",
		cmdp->url, return_path(cmdp), envstr(cmdp));

	eprintf(cmdp, "</UL><HR></BODY></HTML>\n");
}

/*
 *   keybuf Ƥ
 */
putkeybuf(cmdp, buf)
	u_long	*buf;
	struct	command *cmdp;
{
	u_long	c, *p = buf;
	u_char	*sp;

	sp = sbuf;
	while (c = *p++) {
		if (c & HGAIJI) {
			putgaiji(cmdp, sp, c & 0xffff, 0);
			sp += strlen(sp);
			continue;
		}
		if (c & FGAIJI) {
			putgaiji(cmdp, sp, c & 0xffff, 1);
			sp += strlen(sp);
			continue;
		}
		if (c > 0xff)
			*sp++ = (c >> 8) & 0xff;
		*sp++ = c & 0xff;
	}
	*sp = 0;
	eprintf(cmdp, "%s", sbuf);
}

/*
 *   inline imageȤhtmlǽ
 */
putgaiji(cmdp, buf, c, full)
	struct	command *cmdp;
	u_char	*buf;
{
	int	size = cmdp->fontsize;

	sprintf(buf, "<img align=top\n\tsrc=\"%s?path=%sgaiji/%d%c/%x.%s\"\n\twidth=%d height=%d>",
		cmdp->url, dict_path(cmdp),
		size, full ? 'f' : 'h', c, IMAGE_FORMAT,
		full ? size : size / 2, size + cmdp->goff);
	column = 0;
}

/*
 *   Ǥinline imageȤhtmlǽ (ޤ礭ʤ)
 */
eputfig(cmdp, page, offset)
	struct	command *cmdp;
	u_long	page, offset;
{
	eprintf(cmdp, "<img\nalign=top src=\"%s?path=%sfig/%x:%x.%s\"\n>",
		cmdp->url, dict_path(cmdp), page, offset, IMAGE_FORMAT);
	column = 0;
}

/*
 *   顼(Windows BMP)inline imageȤhtmlǽ
 */
eputbmpfig(cmdp, page, offset)
	struct	command *cmdp;
	u_long	page, offset;
{
	eprintf(cmdp, "<img\nalign=top src=\"%s?path=%sbmpfig/%x:%x.%s\"\n>",
		cmdp->url, dict_path(cmdp), page, offset, IMAGE_FORMAT);
	column = 0;
}

/*
 *   Ǥinline imageȤhtmlǽ (ޤ礭դξ)
 */
eputfig1(cmdp, page, offset, wd, ht)
	struct	command *cmdp;
	u_long	page, offset;
{
	eprintf(cmdp,
		"<img align=top\n\tsrc=\"%s?path=%sfig/P%x:%x:%x:%x.%s\"\n\twidth=%d height=%d>",
		cmdp->url, dict_path(cmdp),
		page, offset, wd, ht, IMAGE_FORMAT,
		wd, ht);
	column = 0;
}

/*
 *   Ȥhtmlǽ
 */
eputsnd(cmdp, page, offset)
	struct	command *cmdp;
	u_long	page, offset;
{
	eprintf(cmdp, "<a\nhref=\"%s?path=%ssound/%x:%x.au\"\n>",
		cmdp->url, dict_path(cmdp), page, offset);
	column = 0;
}

/*
 *   Ȥhtmlǽ (EPWING Ver.2)
 */
eputpcmsnd(cmdp, pg, off, epg, eoff)
	struct	command *cmdp;
	u_long	pg, off, epg, eoff;
{
	eprintf(cmdp, "<a\nhref=\"%s?path=%spcmsnd/%x:%x:%x:%x.au\"\n>β",
		cmdp->url, dict_path(cmdp), pg, off, epg, eoff);
	column = 0;
}

/*
 *   ܻȤhtmlǽ
 */
eputcolor(cmdp, val, val1)
	struct	command *cmdp;
	u_long	val, val1;
{
	eprintf(cmdp, "<a\nhref=\"%s?path=%scolor/%x:%x.gif\"\n>",
		cmdp->url, dict_path(cmdp), val, val1);
	column = 0;
}

static u_char *unimpl =
"Content-Type: text/html\n\n\
<HTML><HEAD><TITLE>unimplemented</TITLE></HEAD>\n\
<BODY>\n\
θˡϤޤ¸Ƥޤ<BR>\n\
͡\n\
</BODY>\n</HTML>\n";

do_unimp(cmdp, tp)
	struct	commnd *cmdp;
	struct	toc *tp;
{
	eprintf(cmdp, unimpl);
}
