/*
 * Copyright (c) 1994 Noriyuki Shiota.  All rights reserved.
 *
 * $Id: romatbl.c,v 1.1 1995/03/08 07:56:09 root Exp $
 */
#include <sys/types.h>
#include <stdio.h>
#include "ebs.h"

#define	SZ(x)	(sizeof(x) / sizeof(struct romatbl))
#define	NODET(c, s)	{  (c),	0,	(struct romatbl *)(s) }
#define	NODEN(c, t)	{  (c),	SZ(t),	(t) }

static struct romatbl K_tbl[] = {
	NODET('A',	""),
	NODET('E',	""),
};
static struct romatbl T_tbl[] = {
	NODET('U',	""),
};
static struct romatbl W_tbl[] = {
	NODET('A',	""),
};
static struct romatbl Y_tbl[] = {
	NODET('A',	""),
	NODET('O',	""),
	NODET('U',	""),
};
static struct romatbl by_tbl[] = {
	NODET('a',	"Ӥ"),
	NODET('e',	"Ӥ"),
	NODET('i',	"Ӥ"),
	NODET('o',	"Ӥ"),
	NODET('u',	"Ӥ"),
};
static struct romatbl b_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('y',	by_tbl),
};
static struct romatbl ch_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl cy_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl c_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODEN('h',	ch_tbl),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('y',	cy_tbl),
};
static struct romatbl dh_tbl[] = {
	NODET('a',	"Ǥ"),
	NODET('e',	"Ǥ"),
	NODET('i',	"Ǥ"),
	NODET('o',	"Ǥ"),
	NODET('u',	"Ǥ"),
};
static struct romatbl dy_tbl[] = {
	NODET('a',	"¤"),
	NODET('e',	"¤"),
	NODET('i',	"¤"),
	NODET('o',	"¤"),
	NODET('u',	"¤"),
};
static struct romatbl dw_tbl[] = {
	NODET('a',	"ɤ"),
	NODET('e',	"ɤ"),
	NODET('i',	"ɤ"),
	NODET('o',	"ɤ"),
	NODET('u',	"ɤ"),
};
static struct romatbl d_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODEN('h',	dh_tbl),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('w',	dw_tbl),
	NODEN('y',	dy_tbl),
};
static struct romatbl fw_tbl[] = {
	NODET('a',	"դ"),
	NODET('e',	"դ"),
	NODET('i',	"դ"),
	NODET('o',	"դ"),
	NODET('u',	"դ"),
};
static struct romatbl fy_tbl[] = {
	NODET('a',	"դ"),
	NODET('e',	"դ"),
	NODET('i',	"դ"),
	NODET('o',	"դ"),
	NODET('u',	"դ"),
};
static struct romatbl f_tbl[] = {
	NODET('a',	"դ"),
	NODET('e',	"դ"),
	NODET('i',	"դ"),
	NODET('o',	"դ"),
	NODET('u',	""),
	NODEN('w',	fw_tbl),
	NODEN('y',	fy_tbl),
};
static struct romatbl gw_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl gy_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl g_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('w',	gw_tbl),
	NODEN('y',	gy_tbl),
};
static struct romatbl hy_tbl[] = {
	NODET('a',	"Ҥ"),
	NODET('e',	"Ҥ"),
	NODET('i',	"Ҥ"),
	NODET('o',	"Ҥ"),
	NODET('u',	"Ҥ"),
};
static struct romatbl h_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('y',	hy_tbl),
};
static struct romatbl jy_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl j_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('y',	jy_tbl),
};
static struct romatbl ky_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl k_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('y',	ky_tbl),
};
static struct romatbl ly_tbl[] = {
	NODET('a',	""),
	NODET('e',	"ꤧ"),
	NODET('i',	"ꤣ"),
	NODET('o',	"ꤩ"),
	NODET('u',	"ꤥ"),
};
static struct romatbl l_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('y',	ly_tbl),
};
static struct romatbl my_tbl[] = {
	NODET('a',	"ߤ"),
	NODET('e',	"ߤ"),
	NODET('i',	"ߤ"),
	NODET('o',	"ߤ"),
	NODET('u',	"ߤ"),
};
static struct romatbl m_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('y',	my_tbl),
};
static struct romatbl ny_tbl[] = {
	NODET('a',	"ˤ"),
	NODET('e',	"ˤ"),
	NODET('i',	"ˤ"),
	NODET('o',	"ˤ"),
	NODET('u',	"ˤ"),
};
static struct romatbl n_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('n',	""),
	NODET('\'',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('y',	ny_tbl),
};
static struct romatbl py_tbl[] = {
	NODET('a',	"Ԥ"),
	NODET('e',	"Ԥ"),
	NODET('i',	"Ԥ"),
	NODET('o',	"Ԥ"),
	NODET('u',	"Ԥ"),
};
static struct romatbl p_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('y',	py_tbl),
};
static struct romatbl qy_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl qw_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl q_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('w',	qw_tbl),
	NODEN('y',	qy_tbl),
};
static struct romatbl ry_tbl[] = {
	NODET('a',	""),
	NODET('e',	"ꤧ"),
	NODET('i',	"ꤣ"),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl r_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('y',	ry_tbl),
};
static struct romatbl sh_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl sw_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl sy_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl s_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODEN('h',	sh_tbl),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('w',	sw_tbl),
	NODEN('y',	sy_tbl),
};
static struct romatbl th_tbl[] = {
	NODET('a',	"Ƥ"),
	NODET('e',	"Ƥ"),
	NODET('i',	"Ƥ"),
	NODET('o',	"Ƥ"),
	NODET('u',	"Ƥ"),
};
static struct romatbl ts_tbl[] = {
	NODET('a',	"Ĥ"),
	NODET('e',	"Ĥ"),
	NODET('i',	"Ĥ"),
	NODET('o',	"Ĥ"),
	NODET('u',	""),
};
static struct romatbl tw_tbl[] = {
	NODET('a',	"Ȥ"),
	NODET('e',	"Ȥ"),
	NODET('i',	"Ȥ"),
	NODET('o',	"Ȥ"),
	NODET('u',	"Ȥ"),
};
static struct romatbl ty_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl t_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODEN('h',	th_tbl),
	NODET('i',	""),
	NODET('o',	""),
	NODEN('s',	ts_tbl),
	NODET('u',	""),
	NODEN('w',	tw_tbl),
	NODEN('y',	ty_tbl),
};
static struct romatbl vy_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl v_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('y',	vy_tbl),
};
static struct romatbl wh_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl w_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODEN('h',	wh_tbl),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl x_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl y_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl zy_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
};
static struct romatbl z_tbl[] = {
	NODET('a',	""),
	NODET('e',	""),
	NODET('i',	""),
	NODET('o',	""),
	NODET('u',	""),
	NODEN('y',	zy_tbl),
};

struct romatbl romatbl[] = {
	NODET('A',	""),
	NODET('E',	""),
	NODET('I',	""),
	NODEN('K',	K_tbl),
	NODET('O',	""),
	NODEN('T',	T_tbl),
	NODET('U',	""),
	NODEN('Y',	Y_tbl),
	NODEN('W',	W_tbl),
	NODET('a',	""),
	NODEN('b',	b_tbl),
	NODEN('c',	c_tbl),
	NODEN('d',	d_tbl),
	NODET('e',	""),
	NODEN('f',	f_tbl),
	NODEN('g',	g_tbl),
	NODEN('h',	h_tbl),
	NODET('i',	""),
	NODEN('j',	j_tbl),
	NODEN('k',	k_tbl),
	NODEN('l',	l_tbl),
	NODEN('m',	m_tbl),
	NODEN('n',	n_tbl),
	NODET('o',	""),
	NODEN('p',	p_tbl),
	NODEN('q',	q_tbl),
	NODEN('r',	r_tbl),
	NODEN('s',	s_tbl),
	NODEN('t',	t_tbl),
	NODET('u',	""),
	NODEN('v',	v_tbl),
	NODEN('w',	w_tbl),
	NODEN('x',	x_tbl),
	NODEN('y',	y_tbl),
	NODEN('z',	z_tbl),
};

int	rmtblsize = SZ(romatbl);
