/*
 * Copyright (c) 1994,1995 Noriyuki Shiota. All rights reserved.
 *
 * $Id: ebs.h,v 1.5 1997/05/23 16:08:24 root Exp $
 */
/*
 *   CD-ROMξݻ빽¤
 */
struct disc {
	struct	disc	*dc_next;	/*  CD-ROM ؤΥ */
	struct	dict	*dc_dict;	/* CD-ROMμؤΥ */
	u_char		*dc_name;	/* CD-ROM̾ */
	u_char		*dc_path;	/* CD-ROMΥޥȥݥ */
	u_short		 dc_ndict;	/* CD-ROMμο */
	u_short		 dc_flags;	/* ե饰 */
	u_short		 dc_discno;	/* CD-ROMֹ */
};
/* dc_flags */
#define	DCF_EBOOK	0x01	/* Żҥ֥å */
#define	DCF_EPWING	0x02	/* EPWING */
#define	DCF_VALID	0x80	/*  */

/*
 *   CD-ROM1Ĥμξݻ빽¤
 */
struct dict {
	struct	dict	*dt_next;	/* μؤΥ */
	struct	disc	*dt_disc;	/* backpointer to disc */
	FILE		*dt_fp;		/* եfile pointer */
	u_char		*dt_name;	/* ̾ */
	u_char		*dt_path;	/* path */
	u_char		*dt_lockpath;	/* lock file path */
	u_char		*dt_dir;	/* subdirectory */
	struct	toc	*dt_toc;	/* ؤΥ */
	struct	gaiji	*dt_gaiji;	/* ؤΥ */
	u_short		 dt_ghbase;	/* Ⱦѳγϥ */
	u_short		 dt_gfbase;	/* ѳγϥ */
	u_short		 dt_dictno;	/* ֹ */
	u_short		 dt_padding;
	struct wordsrch *dt_word;	/* ñ측ؤΥ */
};

/*
 *   ݻ빽¤
 *   (tocϺǤϤʤܼʤǤ:-)
 */
struct toc {
	struct	toc	*tc_next;	/* κؤΥ */
	struct	dict	*tc_dict;	/* ؤback pointer */
	u_char		 tc_type;	/* Υ */
	short		 tc_tocno;	/* ֹ */
	short		 tc_no;		/* ʣ縡Ѥֹ */
	u_long		 tc_start;	/* ϥڡֹ */
	u_long		 tc_length;	/* ڡĹ */
	u_long		 tc_flags;	/* ե饰 */
};
#define	TCF_MULTI	1	/* ʣ縡ѤκǤ */

/*
 *   ݻ빽¤
 */
struct gaiji {
	struct	gaiji	*gj_next;	/* γؤΥ */
	struct	dict	*gj_dict;	/* ؤback pointer */
	FILE		*gj_fp;		/* եfile pointer */
	u_char		*gj_path;	/* եpath */
	u_long		 gj_offset;	/* Υեå */
	u_short		 gj_basecode;	/* ϥ */
	u_short		 gj_nchars;	/* ʸ */
	u_char		 gj_file_width;	/* ǡʸ (bit) */
	u_char		 gj_file_height;/* ǡʸ (bit) */
	u_char		 gj_width;	/* ʸ (bit) */
	u_char		 gj_height;	/* ʸ (bit) */
	u_short		 gj_unit;	/* 1ʸΥǡ (byte) */
	u_short		 gj_adj;	/* ڡ (byte) */
	u_long		 gj_flags;	/* ե饰 */
	u_char	       **gj_alttbl;	/* ɽ (ʤ NULL) */
};
/* fj_flags */
#define	GJF_SEPARATE	1	/* ḁ̇̄ե˻ */
#define	GJF_NEEDADJ	2	/* ڡɬ */
#define	GJF_HANKAKU	4	/* ȾʸǤ */

/*
 *  ñ측ݻ빽¤
 */
#define	NSEARCHCHAR	4
#define WD_KANA		0	/*  */
#define	WD_HYOUKI	1	/* ɽ */
#define	WD_ALPHA	2	/* ѻ */
#define	WD_KANJI	3	/*  */
#define	WD_UNSPEC	99
#define	WSDESCLEN	30
struct wordsrch {
	struct dict	*ws_dict;
	int		 ws_type;
	u_char		 ws_name[WSDESCLEN];	/* ˡʸɽ */
	struct toc	*ws_exact[NSEARCHCHAR];	/* ׸Ѻ */
	struct toc	*ws_forw[NSEARCHCHAR];	/* Ѻ */
	struct toc	*ws_back[NSEARCHCHAR];	/* Ѻ */
};

/*
 *   ︡ѥѥ᡼
 */
#define	COND_ENTRY_SIZE	20
#define	COND_ENTRY_MAX	64

#ifndef COMPLEX_CONDITION

#define	COND_N_NODE	5

/* ︡ݻ빽¤ */
struct condnode {
	int	not;
	char	*key;
	int	roma;
	u_short	*skey;
};

#else /* CONPLEX_CONDITION */

#define	COND_N_LEAF	4
#define	COND_N_NODE	2

#define	OP_AND		1
#define	OP_OR		2

struct condleaf {
	int	op;
	int	not;
	char	*key;
	int	roma;
};

struct condnode {
	int	op;
	struct	condleaf condleaf[COND_N_LEAF];
};

#endif /* CONPLEX_CONDITION */

/*
 *   桼׵ݻ빽¤
 */
struct command {
	FILE		*fp;		/* 饤ȤȤ̿ fp */
	u_char		*path;		/* path */
	u_char		*cpath;		/* pathθ߰ */
	u_char		*key;		/* ñ측 */
	u_char		*url;		/* url */
	struct condnode	condnode[COND_N_NODE]; /* ︡ */
	int		serverno;	/* server no */
	int		fontsize;	/* եȥ */
	int		code;		/* ܸ쥳ɼ */
	int		goff;		/* եå */
	int		type;		/* ˡ */
	int		romkana;	/* ޻ѴԤʤ */
	int		index;		/* index type to search */
	int		dispitem;	/* item display mode */
	u_long		page;		/* ڡֹ */
	u_long		offset;		/* եå */
	u_long		position;	/* եΰ */
	int		lockf;		/* lock file descriptor */
};
/* code */
#define	CD_UNDEF	0
#define	CD_JIS		1
#define	CD_EUC		2
#define	CD_SJIS		3
/* romkana */
#define	RK_UNDEF	0
#define	RK_NONE		1
#define	RK_HIRA		2
#define	RK_KATA		3

/* toctbl flags */
#define	ST_MASK		0x000f
#define	ST_WORD		0x0001
#define	ST_COND		0x0002
#define	ST_CROSS	0x0003
#define	ST_NUMBER	0x0004
#define	ST_PAGE		0x0005
#define	ST_SOUKAKU	0x0006
#define	ST_BUSYUKAKU	0x0007
#define	ST_MULTI	0x0008
#define	ST_NORM		0x0009
#define	ST_GRAPH	0x000a
#define	SD_MASK		0x0f00
#define	SD_FORW		0x0100
#define	SD_BACK		0x0200
#define	SD_EXACT	0x0400
#define	SC_MASK		0xf000
#define	SC_KANA		0x1000
#define	SC_HYOUKI	0x2000
#define	SC_ALPHA	0x4000
#define	SC_KANJI	0x8000

struct toctbl {
	int	type;
	int	flags;
	int	(*func)();
	u_char	*name;
};

/* return value of get_chartype() */
#define	CT_ALPHA	0x01
#define	CT_KANA		0x04
#define	CT_KANJI	0x08
#define	CT_OTHER	0x10

/* search type */
#define TY_EXACT	1
#define TY_FORW		2
#define TY_BACK		3
#define TY_COND		4
#define TY_MULTI	5
#define TY_CROSS	6

struct	entry {
	struct	entry	*next;
	u_long		 hpg;
	u_long		 mpg;
	u_short		 hoff;
	u_short		 moff;
	u_short		 pos;
	u_short		 dummy;
};
#define	ALLENTRY	((struct entry *)-1)

/* entry_sort */
#define	SOT_MASK	0x0f
#define	SOT_HONMON	0x00
#define	SOT_MIDASHI	0x01
#define	SOD_MASK	0xf0
#define	SOD_ASCEND	0x00
#define	SOD_DESEND	0x10

#ifdef COMPLEX_CONDITION
/* cond search */
/* op type */
#define	COP_TYPE_MASK	0x0f
#define	COP_LEAF	0x00
#define	COP_NODE	0x01
/*   op type = COP_NODE */
#define	COP_AND		0x10
#define	COP_OR		0x20
/*   op type = COP_LEAF */
#define	COP_ROMA	0x10
#define	COP_NOT		0x20

#define	COP_NOT_CLAUSE	0x40

#define	IS_CLEAF(p)	(((p)->cond_op & COP_TYPE_MASK) == COP_LEAF)
#define	IS_CNODE(p)	(((p)->cond_op & COP_TYPE_MASK) == COP_NODE)

struct	cond {
	int		cond_op;
	union {
		struct cond	*ul_left;
		u_short		*ul_okey;
	} u_left;
	union {
		struct cond	*ur_right;
		u_short		*ur_key;
	} u_right;
	struct entry	*cond_entry;
};
#define	cond_left 	u_left.ul_left
#define	cond_okey	u_left.ul_okey
#define	cond_right	u_right.ur_right
#define	cond_key	u_right.ur_key
#endif /* COMPLEX_CONDITION */

/* romatbl */
struct romatbl {
	u_char		 ch;
	u_short		 size;
	struct	romatbl	*next;
};

/*
 *   defaultconfեpath
 */
#ifndef CONFIG_FILE
#define CONFIG_FILE	"/usr/local/etc/ebw3d.conf"
#endif

/*
 *   default̿ѥݡֹ(tcp)
 */
#define	EBSP_DEFAULT_PORT	9138

#define	DEFAULT_GOFFSET		1	/* defaultγեå */
#define	MAX_GOFFSET		3	/* եåȤκ */
#define	DEFAULT_FONTSIZE	16	/* defaultγ */

#define	EB_CATALOG	"catalog"	/* Żҥ֥åcatalogե̾ */
#define	EB_MAINFILE	"start"		/* Żҥ֥åʸե̾ */
#define EPW_CATALOG	"catalogs"	/* EPWINGcatalogե̾ */
#define	EPW_MAINFILE	"data/honmon"	/* EPWINGʸե̾ */
#define	EPW_GAIJIDIR	"gaiji"		/* EPWINGγǥ쥯ȥ̾ */

#define	FRAMESIZE	2048		/* ڡ */

#define	GALIGN		1024

#define	P_PATHMAX	128
#define	P_KEYLEN	128

#define	MALLOC(type)	((type *)xmalloc(sizeof(type)))
#ifndef MAX
#define	MAX(a, b)	((a) > (b) ? (a) : (b))
#endif
#ifndef MIN
#define	MIN(a, b)	((a) < (b) ? (a) : (b))
#endif
#define	GETW(c, fp)	((c) = (getc(fp) << 8), (c) |= getc(fp))
#define	DPR(x)		(debug > 0 ? fprintf x : 0)

/* little endian to host short */
#define	letohs(s)	(*(u_char *)&(s) + (*(((u_char *)&(s)) + 1) << 8))

/*
 * Sun audio file header
 */
struct au_hdr {
	u_long	magic;		/* magic number */
	u_long	hdr_size;	/* sizeof header */
	u_long	data_size;	/* data length */
	u_long	encoding;	/* encoding format */
	u_long	sample_rate;	/* sample per second */
	u_long	channels;	/* number of channels */
};
#define	SUN_AU_MAGIC	0x2e736e64
#define	SUN_ULAW_8	1	/* 8bit u-law */
#define	SUN_LIN_8	2	/* 8 bit linear */
#define	SUN_LIN_16	3	/* 16 bit linear */
#define	SUN_LIN_24	4	/* 24 bit linear */
#define	SUN_LIN_32	5	/* 32 bit linear */

extern struct disc	*discp;
extern struct toctbl	toctbl[];
extern int		debug;
extern struct romatbl	romatbl[];
extern int		rmtblsize;

#define	XBUFSIZE	1024
extern u_char		xbuf[XBUFSIZE];
extern int		xcnt;
extern u_char		*xbp;
#define	xputc(c, fp)	(*xbp++ = (c), (++xcnt >= XBUFSIZE ? xflush(fp) : 0))

#ifndef MALLOC_DEBUG
#define xfree(p)	free(p)
#endif
extern char	*return_path();
extern char	*current_path();
extern char	*dict_path();
extern u_char	*toeuc();
extern void	*xmalloc();
extern u_short	*usstrdup();
extern char	*envstr();
