/*
 * Copyright (c) 1994 Noriyuki Shiota.  All rights reserved.
 *
 * $Id: format.h,v 1.2 1996/04/22 01:18:08 root Exp $
 */

/*
 *  CATALOG(Żҥ֥å)/CATALOGS(EPWING)եΥեޥå
 *
 *	16ХȤΥإåθ塢ҿʬνҥ쥳ɤ¤Ǥ
 */

/*
 *  إå(Ƭ16Х)η
 */
struct cat_head {
	u_short	numbook;	/* ҿ: big endian */
	u_short	field1;		/* : EPWINGǤ 1 äƤ */
	u_char	padding[12];	/* ٤0 */
};

/*
 *  Żҥ֥å(EB)νҥ쥳
 */
#define	EB_BOOKNAMELEN	30	/* ̾Ĺ */
#define	EB_DIRLEN	8	/* ǥ쥯ȥĹ */

struct cat_book_eb {
	u_short	bookno;			/* ֹ: little endian (1) */
	u_char	name[EB_BOOKNAMELEN];	/* ̾: ;0 */
	u_char	dir[EB_DIRLEN];		/* ǥ쥯ȥ: ;0x20 */
};

/*
 *  EPWINGνҥ쥳
 */
#define	EPW_BOOKNAMELEN	80	/* ̾Ĺ */
#define	EPW_DIRLEN	8	/* ǥ쥯ȥĹ */
#define	EPW_GAFILELEN	8	/* եĹ */

struct cat_book_ep {
	u_short	field1;			/* : Ǥ 1 */
	u_char	name[EPW_BOOKNAMELEN];	/* ̾: ;0 */
	u_char	dir[EPW_DIRLEN];	/* ǥ쥯ȥ: ;0x20 */
	u_short	field2[2];		/* : 0 */
	u_short field3;			/* : 1 */
	u_short field4[2];		/* : 0 */
	u_char	gf16[EPW_GAFILELEN];	/* ե 16dot */
	u_char	gf24[EPW_GAFILELEN];	/* ե 24dot */
	u_char	gf30[EPW_GAFILELEN];	/* ե 30dot */
	u_char	gf48[EPW_GAFILELEN];	/* ե 48dot */
	u_char	gh16[EPW_GAFILELEN];	/* ե Ⱦ16dot */
	u_char	gh24[EPW_GAFILELEN];	/* ե Ⱦ24dot */
	u_char	gh30[EPW_GAFILELEN];	/* ե Ⱦ30dot */
	u_char	gh48[EPW_GAFILELEN];	/* ե Ⱦ48dot */
};

/*
 *  ᥤե (start.: Żҥ֥å/honmon: EPWING) 
 *  ǽˤܼη
 */

struct bk_head {
	u_short	numtoc;		/* ܼ */
	u_short	field1;		/*  */
	u_char	padding[12];	/* : 0 */
};

struct bk_toc {
	u_char	type;		/* ܼ */
	u_char	field1;		/* : 0x0, 0x0a, 0x14 */
	u_char	start[4];	/* ϥڡ (١1) */
	u_char	length[4];	/* ǡĹ(ڡ) */
	u_short	field2;		/* : 0x100, 0x200, 0x241 */
	u_short field3;		/* : 0, 0x5540 */
	u_short	field4;		/* : 0 */
};
/* type */
#define	T_HONMON		0x00	/* ʸǡ */
#define	T_MENU			0x01	/* ˥塼ɽǡ */
#define	T_COPYRIGHT		0x02	/* ɽǡ */
#define	T_TITLE_COND		0x03	/* ︡ѸФǡ */
#define	T_TITLE_FORW_KANA	0x04	/* פʸѸФǡ */
#define	T_TITLE_FORW		0x05	/* ɽѸФǡ */
#define	T_TITLE_BACK_KANA	0x06	/* פʸѸФǡ */
#define	T_TITLE_BACK		0x07	/* ɽѸФǡ */
#define	T_TITLE_FORW_ALPHA	0x08	/* ױѻѸФǡ */
#define	T_TITLE_BACK_ALPHA	0x09	/* ױѻѸФǡ */
#define	T_TITLE_CROSS		0x0a	/* Ф
							     Фǡ */
#define	T_TITLE_NUMBER		0x0b	/* ѸФǡ */
#define	T_GRAPH			0x0e	/* եå */
#define	T_XXX1			0x0f	/* ??? */
#define	T_MENU2			0x20	/* ˥塼ɽǡ2 */
#define	T_COPYRIGHT2		0x21	/* ɽǡ2 */
#define	T_COPYRIGHT3		0x23	/* ɽǡ3 */
#define	T_TITLE_SOUND		0x24	/* ǡѸФǡ */
#define	T_INDEX_KANA		0x30	/* ʸѥǥå */
#define	T_INDEX_ALPHA		0x40	/* ѻѥǥå */
#define	T_INDEX_KANJI		0x50	/* ѥǥå */
#define	T_INDEX_HYOKI		0x60	/* ɽѥǥå */
#define	T_INDEX_BACK_KANA	0x70	/* פʸѥǥå */
#define	T_INDEX_BACK		0x71	/* ɽѥǥå */
#define	T_INDEX_BACK_ALPHA	0x72	/* ױѻѥǥå */
#define	T_INDEX_COND		0x80	/* ︡ѥǥå */
#define	T_INDEX_CROSS		0x81	/* Ф
							     ǥå */
#define	T_INDEX_FORW_KANA	0x90	/* פʸѥǥå */
#define	T_INDEX_FORW		0x91	/* ɽѥǥå */
#define	T_INDEX_FORW_ALPHA	0x92	/* ױѻѥǥå */
#define	T_INDEX_NUMBER		0xa0	/* ֹ()ǥå */
#define	T_INDEX_PAGE		0xb0	/* ڡѥǥå */
#define	T_INDEX_SOUKAKU		0xb1	/* ǥå */
#define	T_INDEX_BUSYUKAKU	0xb1	/* ǥå */
#define	T_ZUHAN			0xd0	/* ǥǡ */
#define T_XXX2			0xd1	/* ??? */
#define	T_COLORFIG		0xd2	/* */
#define	T_SOUND			0xd8	/* */
#define	T_IRO			0xe0	/* ɽѥǡ */
#define	T_ANSHO			0xf0	/* žڥǡ */
#define	T_GAIJI_FULL16		0xf1	/* ե(16ɥå) */
#define	T_GAIJI_HALF16		0xf2	/* ե(16ɥåȾ) */
#define	T_MULTI_INDEX		0xff	/* ʣ縡ѥǥå */

/*
 *   ǡ(ե)η
 */
struct gj_head {
	u_char	field1;		/* : 1 */
	u_char	field2[7];	/* : 0 */
	u_char	width;		/* ʸ(ɥå) */
	u_char	height;		/* ʸ(ɥå) */
	u_short	start;		/* ϥ */
	u_short	nchars;		/* ʸĿ */
	u_short	field3;		/* : 0 */
};

/*
 *
 */
#define	H_CONTROL	0x1f

#define	L_DOC_START	0x02
#define	L_DOC_END	0x03

#define	L_HALF_START	0x04
#define	L_HALF_END	0x05

#define	L_TAB		0x09
#define	L_LF		0x0a

#define	L_SUPER_START	0x0e
#define	L_SUPER_END	0x0f

#define	L_NOLF_START	0x10
#define	L_NOLF_END	0x11

#define	L_UNKNOWN_14	0x14
#define	L_UNKNOWN_15	0x15

#define	L_KEY_START	0x41
#define	L_KEY_END	0x61

#define	L_REF_START	0x42
#define	L_REF_END	0x62

#define	L_REFMENU_START	0x43
#define	L_REFMENU_END	0x63

#define	L_FIG_SIZE	0x31
#define	L_FIG_POS	0x51
#define	L_FIG_END	0x65
#define	L_FIGIND_START	0x45
#define	L_FIGIND_MID	0x32
#define	L_FIGIND_END	0x52
#define	L_FIGREF_KEY	0x44
#define	L_FIGREF_POS	0x64

#define	L_REFSND_START	0x33
#define	L_REFSND_END	0x53
#define	L_REFSND1_START	0x48
#define	L_REFSND1_END	0x68

#define	L_COLOR_KEY	0x47
#define	L_COLOR_YOMI	0x06
#define	L_COLOR_YOMIE	0x07
#define	L_COLOR_VAL	0x67

/* ʲEPWING񥫥顼ǤǸ줿楳 */

/*
 * 顼 
 *
 *  1f4d 0009 0000 0000 0000 0000 0000
 *	 pppp pppp oooo : page & offset -> Windows  BMP եޥå
 *	 ....      : Ĥϥƥ
 *  1f6d
 */
#define	L_BMPFIG_START	0x4d
#define	L_BMPFIG_END	0x6d

/*
 * 
 *
 *  1f4a 0001 0112
 *	 pppp pppp oooo : γ (page & offset)
 *	 pppp pppp oooo : νλ (page & offset)
 *       ...		: Ĥϥƥ
 *  1f6a
 */
#define	L_PCMSND_START	0x4a
#define	L_PCMSND_END	0x6a

#define	M_DOC_START	((H_CONTROL << 8) | L_DOC_START)
#define	M_DOC_END	((H_CONTROL << 8) | L_DOC_END)
#define	M_TAB		((H_CONTROL << 8) | L_TAB)
#define	M_LF		((H_CONTROL << 8) | L_LF)
#define	M_FIGIND_START	((H_CONTROL << 8) | L_FIGIND_START)
#define	M_FIG_SIZE	((H_CONTROL << 8) | L_FIG_SIZE)
#define	M_FIG_POS	((H_CONTROL << 8) | L_FIG_POS)
#define	M_FIG_END	((H_CONTROL << 8) | L_FIG_END)
#define	M_REFSND_START	((H_CONTROL << 8) | L_REFSND_START)
#define	M_REFSND_END	((H_CONTROL << 8) | L_REFSND_END)
#define	M_RIGREF_KEY	((H_CONTROL << 8) | L_FIGREF_KEY)
#define	M_RIGREF_POS	((H_CONTROL << 8) | L_FIGREF_POS)
