/*
 * Copyright (c) 1994 Noriyuki Shiota.  All rights reserved.
 *
 * $Id: func.c,v 1.4 1996/05/22 19:04:05 root Exp $
 */
#include <sys/types.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include "ebs.h"
#include "format.h"

do_cond(cmdp, tp)
	struct	command *cmdp;
	struct	toc *tp;
{
	do_cond_form(cmdp, tp);
}

do_cross(cmdp, tp)
	struct	command *cmdp;
	struct	toc *tp;
{
	do_unimp(cmdp, tp);
}

do_number(cmdp, tp)
	struct	command *cmdp;
	struct	toc *tp;
{
	do_unimp(cmdp, tp);
}

do_page(cmdp, tp)
	struct	command *cmdp;
	struct	toc *tp;
{
	do_unimp(cmdp, tp);
}

do_soukaku(cmdp, tp)
	struct	command *cmdp;
	struct	toc *tp;
{
	do_unimp(cmdp, tp);
}

do_busyukaku(cmdp, tp)
	struct	command *cmdp;
	struct	toc *tp;
{
	do_unimp(cmdp, tp);
}

do_multi(cmdp, tp)
	struct	command *cmdp;
	struct	toc *tp;
{
	do_unimp(cmdp, tp);
}

do_menu(cmdp, tp)
	struct	command *cmdp;
	struct	toc *tp;
{
	get_position(tp, cmdp);
	return show_honmon(tp->tc_dict->dt_fp, cmdp, tp);
}

do_graph(cmdp, tp)
	struct	command *cmdp;
	struct	toc *tp;
{
	do_unimp(cmdp, tp);
}

do_copyright(cmdp, tp)
	struct	command *cmdp;
	struct	toc *tp;
{
	get_position(tp, cmdp);
	return show_honmon(tp->tc_dict->dt_fp, cmdp, tp);
}

do_honmon(cmdp, tp)
	struct	command *cmdp;
	struct	toc *tp;
{
	get_position(tp, cmdp);
	return show_honmon(tp->tc_dict->dt_fp, cmdp, tp);
}

show_honmon(inp, cmdp, tp)
	FILE	*inp;
	struct	command *cmdp;
	struct	toc *tp;
{
	int	c;

	lockfile(cmdp, tp->tc_dict);
	rewind(inp);
	if (fseek(inp, cmdp->position, SEEK_SET) == -1) {
		perror("show_honmon: fseek");
		return -1;
	}

	put_header(inp, cmdp, tp);

	c = put_honmon(inp, cmdp, tp, -1, 0);

	put_footer(inp, cmdp, tp, c == M_DOC_END, ftell(inp) - 4);

	unlockfile(cmdp);

	return 0;
}
