/*
 * Copyright (c) 1994,1995 Noriyuki Shiota.  All rights reserved.
 *
 * $Id: html2.c,v 1.6 1997/05/23 16:08:24 root Exp $
 */
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include "format.h"
#include "ebs.h"

extern int romaform;

/*
 *   ̤ν
 *	̤1ܤξľʸϡ̤ʣܤäˤ
 *	ܤꥹ<UL>Ȥƽϡ
 */
put_index_page(cmdp, tp, result, key, type)
	struct command *cmdp;
	struct toc *tp;
	struct entry *result;
	u_short *key;
{
	int	c, num, off;
	struct entry *ep;
	struct dict *dt = tp->tc_dict;
	FILE	*inp = dt->dt_fp;

	num = entry_len(result);
	eprintf(cmdp,
		"Content-Type: text/html\n\n<HTML><HEAD><TITLE>Result of search '%s' </TITLE></HEAD>\n",
		cmdp->key);
	if (num == 0) {
		eprintf(cmdp,
			"<BODY><H2>ܤޤ</H2></BODY></HTML>\n");
		return;
	}
	if (num == 1) {
		do_search_form(cmdp, dt, dt->dt_word);
		ep = result;
		lockfile(cmdp, tp->tc_dict);
		c = do_put_data(cmdp, dt, ep->hpg, ep->hoff);
		put_footer(inp, cmdp, tp, c == M_DOC_END, ftell(inp) - 4);
		unlockfile(cmdp);
		return;
	}
	do_search_form(cmdp, dt, dt->dt_word);
	if (cmdp->type == SD_EXACT && cmdp->dispitem) {
		ep = result;
		lockfile(cmdp, tp->tc_dict);
		c = do_put_data(cmdp, dt, ep->hpg, ep->hoff);
		off = ftell(inp) - 4;
		eprintf(cmdp, "<HR>\n<UL><H2>¾γܡ%d</H2>\n",
			num - 1);
		rewind(dt->dt_fp);

		for (ep = ep->next; ep; ep = ep->next) {
			eprintf(cmdp, "<LI><A HREF=\"%s?path=%ssearch/%x:%x%s\">\n\t",
				cmdp->url, dict_path(cmdp),
				ep->hpg, ep->hoff, envstr(cmdp));
			eputkey(cmdp, tp, ep, type);
			eputs("</A>\n", cmdp);
		}
		eprintf(cmdp, "</UL>\n");
		put_footer(inp, cmdp, tp, c == M_DOC_END, off);
		unlockfile(cmdp);
		return;
	}
	eprintf(cmdp, "<HR><BODY>\n<H2>ܰ %d</H2>\n<UL>\n", num);
	lockfile(cmdp, tp->tc_dict);
	rewind(dt->dt_fp);
	for (ep = result; ep; ep = ep->next) {
		eprintf(cmdp, "<LI><A HREF=\"%s?path=%ssearch/%x:%x%s\">\n\t",
			cmdp->url, dict_path(cmdp),
			ep->hpg, ep->hoff, envstr(cmdp));
		eputkey(cmdp, tp, ep, type);
		eputs("</A>\n", cmdp);
	}
	unlockfile(cmdp);
	eprintf(cmdp, "</UL>\n</BODY>\n</HTML>");
}

/*
 *   path ʸΥեåȤФʸϤ
 *
 *	path:	"/jis/g2/<server-no>/<disc-no>/<dict-no>/..../xxxx:xxxx"
 *				  	    		      ^ cpath
 */
do_data(cmdp, dt)
	struct command *cmdp;
	struct dict *dt;
{
	int	c, pg, off;
	FILE	*inp = dt->dt_fp;
	struct	toc *tp = dt->dt_toc;

	eprintf(cmdp,
		"Content-Type: text/html\n\n<HTML><HEAD><TITLE>Honbun</TITLE></HEAD>\n");
	if (sscanf(cmdp->cpath, "%x:%x", &pg, &off) != 2)
		return -1;
	do_search_form(cmdp, dt, dt->dt_word);
	lockfile(cmdp, dt);
	c = do_put_data(cmdp, dt, pg, off);
	put_footer(inp, cmdp, tp, c == M_DOC_END, ftell(inp) - 4);
	unlockfile(cmdp);
	return 0;
}

/*
 *   pg ڡΥեå off ʸǡϤ
 */
do_put_data(cmdp, dt, pg, off)
	struct command *cmdp;
	struct dict *dt;
{
	FILE	*inp = dt->dt_fp;
	struct	toc *tp = dt->dt_toc;

	cmdp->page = pg;
	cmdp->offset = off;
	cmdp->position = (pg - 1) * FRAMESIZE + off;

	rewind(inp);

	if (fseek(inp, cmdp->position, SEEK_SET) == -1) {
		perror("do_data: fseek");
		return -1;
	}
	eprintf(cmdp, "<HR>\n");
	return put_honmon(inp, cmdp, tp, -1, 0);
}

/*
 *   ñ측formϤ
 */

static u_char	*form_title = "\
Content-Type: text/html\n\n\
<TITLE>ñ측</TITLE>\n\
<H1>%s</H1><HR>\n";

static u_char	*form_error = "\
Content-Type: text/html\n\n\
<TITLE>TEST</TITLE>\n\
<BODY><H1>%s</H1>\n\
Żҥ֥åǤñ측ϻѤǤޤ\n\
</BODY>\n";

do_search_title(cmdp, dt)
	struct command *cmdp;
	struct dict *dt;
{
	struct	wordsrch *wp;

	if ((wp = dt->dt_word) == NULL) {
		eprintf(cmdp, form_error);
		return 0;
	}
	eprintf(cmdp, form_title, dt->dt_name);
	do_search_form(cmdp, dt, wp);
	return 0;
}

static u_char	*form_head = "\
<FORM METHOD=\"GET\" ACTION=\"%s\">\n\
<INPUT TYPE=\"hidden\" NAME=\"path\" VALUE=\"%ssearch/\">\n";

static u_char	*form_input = "ʸ\n\
	<INPUT NAME=\"key\" SIZE=32 MAXLENGTH=64>\n\
<INPUT TYPE=\"submit\" VALUE=\"\">\n\
<INPUT TYPE=\"reset\" VALUE=\"õ\"><BR>\n";

static u_char	*form_input_e = "ʸ\n\
	<INPUT NAME=\"key\" SIZE=32 MAXLENGTH=64>\n\
<INPUT TYPE=\"submit\" VALUE=\"Search\">\n\
<INPUT TYPE=\"reset\" VALUE=\"Clear\"><BR>\n";

do_search_form(cmdp, dt, wp)
	struct command *cmdp;
	struct dict *dt;
	struct	wordsrch *wp;
{
	int	type, first = 0;
	struct toc **tpp;

	eprintf(cmdp, form_head, cmdp->url, dict_path(cmdp));
	eprintf(cmdp, romaform ? form_input_e : form_input);

	eprintf(cmdp, "<SELECT NAME=\"type\">\n");
	type = wp->ws_type;
	eprintf(cmdp, "\t<OPTION VALUE=\"exact\"%s>%s\n",
		cmdp->type == SD_EXACT ? " SELECTED" : "",
		romaform ? "Exact match" : "׸");
	if (type & SD_FORW)
		eprintf(cmdp, "\t<OPTION VALUE=\"forw\"%s>%s\n",
			cmdp->type == SD_FORW ? " SELECTED" : "",
			romaform ? "Forward match" : "׸");
	if (type & SD_BACK)
		eprintf(cmdp, "\t<OPTION VALUE=\"back\"%s>%s\n",
			cmdp->type == SD_BACK ? " SELECTED" : "",
			romaform ? "Backward match" : "׸");
	eprintf(cmdp, "</SELECT>\n");

	switch (cmdp->type) {
	default:
	case SD_EXACT:
		tpp = wp->ws_exact;
		break;
	case SD_FORW:
		tpp = wp->ws_forw;
		break;
	case SD_BACK:
		tpp = wp->ws_back;
		break;
	}
	eprintf(cmdp, "<SELECT NAME=\"index\">\n");
	if (tpp[WD_HYOUKI] != NULL)
		eprintf(cmdp, "\t<OPTION VALUE=\"hyouki\"%s>%s\n",
			cmdp->index == WD_HYOUKI ? " SELECTED" : "",
			romaform ? "Hyouki search" : "ɽ");
	if (tpp[WD_KANA] != NULL)
		eprintf(cmdp, "\t<OPTION VALUE=\"kana\"%s>%s\n",
			cmdp->index == WD_KANA ? " SELECTED" : "",
			romaform ? "Kana search" : "ʸ");
	if (tpp[WD_ALPHA] != NULL)
		eprintf(cmdp, "\t<OPTION VALUE=\"alpha\"%s>%s\n",
			cmdp->index == WD_ALPHA ? " SELECTED" : "",
			romaform ? "Alphabetic search" : "ѻ");
	if (tpp[WD_KANJI] != NULL)
		eprintf(cmdp, "\t<OPTION VALUE=\"kanji\"%s>%s\n",
			cmdp->index == WD_KANJI ? " SELECTED" : "",
			romaform ? "Kanji search" : "");
	eprintf(cmdp, "</SELECT>\n");

	eprintf(cmdp, "<SELECT NAME=\"disp\">\n");
	eprintf(cmdp, "\t<OPTION VALUE=\"cont\"%s>%s\n",
		cmdp->dispitem ? "" : " SELECTED",
		romaform ? "Continuous display" : "Ϣ³ɽ");
	eprintf(cmdp, "\t<OPTION VALUE=\"item\"%s>%s\n",
		cmdp->dispitem ? " SELECTED" : "",
		romaform ? "Item display" : "ɽ");
	eprintf(cmdp, "</SELECT>\n");

	if (type & SC_KANA) {
		if (cmdp->romkana == RK_UNDEF)
			cmdp->romkana = RK_HIRA;
		eprintf(cmdp, "<NOBR>޻Ѵ :\n");
		eprintf(cmdp, "<SELECT NAME=\"romkana\">\n");
		eprintf(cmdp, "\t<OPTION VALUE=\"hira\"%s>%s\n",
			cmdp->romkana == RK_HIRA ? " SELECTED" : "",
			romaform ? "-> Hiragana" : "Ҥ餬");
		eprintf(cmdp, "\t<OPTION VALUE=\"kata\"%s>%s\n",
			cmdp->romkana == RK_KATA ? " SELECTED" : "",
			romaform ? "-> Katakana" : "");
		eprintf(cmdp, "\t<OPTION VALUE=\"no\"%s>%s\n",
			cmdp->romkana == RK_NONE ? " SELECTED" : "",
			romaform ? "None" : "ʤ");
		eprintf(cmdp, "</SELECT></NOBR>\n");
	}
	eprintf(cmdp, "</FORM>\n");
}

/*
 *   ︡formϤ
 */

#ifndef COMPLEX_CONDITION
static u_char	*cond_title = "\
Content-Type: text/html\n\n\
<HTML><HEAD><TITLE>︡</TITLE></HEAD>\n\
<BODY>\n\
<H1>%s</H1><HR>\n\
<FORM HETHOD=\"GET\" ACTION=\"%s\">\n\
ϡꤷ塢\n\
<INPUT TYPE=\"submit\" VALUE=\"\">\n\
򲡤Ʋ\n\
<INPUT TYPE=\"hidden\" NAME=\"path\" VALUE=\"%scsearch/\">\n\
\n\
<PRE>\n\
           ޤ/ޤޤʤ";

static u_char	*cond_title_e = "\
Content-Type: text/html\n\n\
<HTML><HEAD><TITLE>︡</TITLE></HEAD>\n\
<BODY>\n\
<H1>%s</H1><HR>\n\
<FORM HETHOD=\"GET\" ACTION=\"%s\">\n\
ϡꤷ塢\n\
<INPUT TYPE=\"submit\" VALUE=\"Search\">\n\
򲡤Ʋ\n\
<INPUT TYPE=\"hidden\" NAME=\"path\" VALUE=\"%scsearch/\">\n\
\n\
<PRE>\n\
           ޤ/ޤޤʤ";

static u_char	*cond_title_roma = "  ޻Ѵ";

static u_char	*cond_item1 = "\
<INPUT NAME=\"k%02d\" SIZE=%d MAXLENGTH=%d><SELECT NAME=\"n%02d\">\n\
		<OPTION VALUE=\"t\" SELECTED>ޤ\n\
		<OPTION VALUE=\"f\">ޤޤʤ\n\
	</SELECT>";
static u_char	*cond_item1_e = "\
<INPUT NAME=\"k%02d\" SIZE=%d MAXLENGTH=%d><SELECT NAME=\"n%02d\">\n\
		<OPTION VALUE=\"t\" SELECTED>include\n\
		<OPTION VALUE=\"f\">not include\n\
	</SELECT>";

static u_char	*cond_roma = "\
    <SELECT NAME=\"r%02d\">\n\
		<OPTION VALUE=\"n\">̵Ѵ\n\
		<OPTION VALUE=\"h\" SELECTED>\n\
		<OPTION VALUE=\"k\">\n\
	</SELECT>";
static u_char	*cond_roma_e = "\
    <SELECT NAME=\"r%02d\">\n\
		<OPTION VALUE=\"n\">None\n\
		<OPTION VALUE=\"h\" SELECTED>-> Hiragana\n\
		<OPTION VALUE=\"k\">-> Katakana\n\
	</SELECT>";

static u_char	*cond_tail = "\
<INPUT TYPE=\"reset\" VALUE=\"õ\">\n\
</PRE>\n\
\n\
</FORM>\n\
</HTML>\n";
static u_char	*cond_tail_e = "\
<INPUT TYPE=\"reset\" VALUE=\"Clear\">\n\
</PRE>\n\
\n\
</FORM>\n\
</HTML>\n";

do_cond_form(cmdp, tp)
	struct command *cmdp;
	struct toc *tp;
{
	int	i, roma = 0;
	struct wordsrch *wp;
	struct dict *dt = tp->tc_dict;

	if (wp = dt->dt_word)
		roma = (wp->ws_type & SC_KANA) != 0;
	eprintf(cmdp, romaform ? cond_title_e : cond_title,
		dt->dt_name, cmdp->url, return_path(cmdp));
	if (roma)
		eprintf(cmdp, cond_title_roma);
	eputs("\n", cmdp);

	for (i = 0; i < COND_N_NODE; i++) {
		eprintf(cmdp, romaform ? cond_item1_e : cond_item1,
			i, COND_ENTRY_SIZE, COND_ENTRY_MAX, i);
		if (roma)
			eprintf(cmdp, romaform ? cond_roma_e : cond_roma, i);
		eputs("\n", cmdp);
	}
	eputs(romaform ? cond_tail_e : cond_tail, cmdp);
	return 0;
}

#else /* COMPLEX_CONDITION */

static u_char	*cond_title = "\
Content-Type: text/html\n\n\
<HTML><HEAD><TITLE>︡</TITLE></HEAD>\n\
<BODY>\n\
<H1>%s</H1><HR>\n\
<FORM HETHOD=\"GET\" ACTION=\"%s\">\n\
ϡꤷ塢\n\
<INPUT TYPE=\"submit\" VALUE=\"\">\n
򲡤Ʋ\n\
<INPUT TYPE=\"hidden\" NAME=\"path\" VALUE=\"%scsearch/\">\n\
\n\
<PRE>\n
                                 ޤ/ޤޤʤ";

static u_char	*cond_title_roma = "     ޻Ѵ";

static u_char	*cond_item1 = "\
                 <INPUT NAME=\"k%02d\" SIZE=%d MAXLENGTH=%d><SELECT NAME=\"n%02d\">\n\
		<OPTION VALUE=\"t\" SELECTED>ޤ\n\
		<OPTION VALUE=\"f\">ޤޤʤ\n\
	</SELECT>";

static u_char	*cond_roma = "\
<SELECT NAME=\"r%02d\">\n\
		<OPTION VALUE=\"n\">̵Ѵ\n\
		<OPTION VALUE=\"h\" SELECTED>\n\
		<OPTION VALUE=\"k\">\n\
	</SELECT>";

static u_char	*cond_item2 = "\
    <SELECT NAME=\"a%02d\">\n\
		<OPTION VALUE=\"a\" SELECTED>
		<OPTION VALUE=\"o\">ޤ
	</SELECT><INPUT NAME=\"k%02d\" SIZE=%d MAXLENGTH=%d><SELECT NAME=\"n%02d\">\n\
		<OPTION VALUE=\"t\" SELECTED>ޤ\n\
		<OPTION VALUE=\"f\">ޤޤʤ\n\
	</SELECT>";

static u_char	*cond_sep = "\
<SELECT NAME=\"o%d\">\n
		<OPTION VALUE=\"o\" SELECTED>ޤ
		<OPTION VALUE=\"a\">
	</SELECT>  (Υ֥åȲΥ֥åδطꤷޤ)\n";

static u_char	*cond_tail = "\
          \n\
        (ƥեɴ֤δطꤷޤ夫֤˷礷ޤ)\n\
</PRE>\n\
\n\
</FORM>\n\
</HTML>\n";

do_cond_form(cmdp, tp)
	struct command *cmdp;
	struct toc *tp;
{
	int	i, roma = 0;
	struct wordsrch *wp;
	struct dict *dt = tp->tc_dict;

	if (wp = dt->dt_word)
		roma = (wp->ws_type & SC_KANA) != 0;
	eprintf(cmdp, cond_title, dt->dt_name, cmdp->url, return_path(cmdp));
	if (roma)
		eprintf(cmdp, cond_title_roma);
	eputs("\n", cmdp);

	put_cond_leaf_form(cmdp, dt, roma, 0);
	for (i = 1; i < COND_N_NODE; i++) {
		eprintf(cmdp, cond_sep, i);
		put_cond_leaf_form(cmdp, dt, roma, i * 10);
	}
	eputs(cond_tail, cmdp);
	return 0;
}

put_cond_leaf_form(cmdp, dt, roma, ind)
	struct command *cmdp;
	struct dict *dt;
{
	int	i;

	eprintf(cmdp, cond_item1,
		 ind, COND_ENTRY_SIZE, COND_ENTRY_MAX, ind);
	if (roma)
		eprintf(cmdp, cond_roma, ind);
	eputs("\n", cmdp);
	for (i = 1; i < COND_N_LEAF; i++) {
		eprintf(cmdp, cond_item2, ind + i, ind + i, COND_ENTRY_SIZE,
			COND_ENTRY_MAX, ind + i);
		if (roma)
			eprintf(cmdp, cond_roma, ind);
		eputs("\n", cmdp);
	}
}
#endif /* COMPLEX_CONDITION */

/*
 *   ФǡϤ
 */
eputkey(cmdp, tp, ep, type)
	struct command *cmdp;
	struct toc *tp;
	struct entry *ep;
{
	int	off, skip;
	FILE	*inp = tp->tc_dict->dt_fp;
	static	int offsv, skipsv;

	if (type == TY_EXACT) {
		/* פΤȤʸǡ鸫ФʬΤߤɽ */
		off = (ep->hpg - 1) * FRAMESIZE + ep->hoff;
		skip = 0;
	}
	else {
		/* ʳϸФǡѤ */
		off = (ep->mpg - 1) * FRAMESIZE + ep->moff;
		skip = ep->pos;
	}
	if (off == offsv && skip == skipsv + 1) {
		/*
		 *  եåȤθƤӽФΤΤƱǡ skip ̤
		 *  1礭硢seek ά
		 *  (ϸФǡϻ֤礭ƶ)
		 */
		skipsv = skip;
		skip = 0;
	}
	else {
		if (skip != 0 || ftell(inp) != off) {
			if (fseek(inp, off, SEEK_SET) == -1) {
				perror("eputkey: fseek 1");
				return -1;
			}
		}
		skipsv = skip;
	}
	offsv = off;
	/*
	 *  LF  skip ĥåפ塢LF ޤǽϤ
	 */
	put_honmon(inp, cmdp, tp, M_LF, skip);
	return 0;
}

/*
 *   顼åhtmlǽϤ
 */
put_error(cmdp, msg)
{
	eprintf(cmdp, "Content-Type: text/html\n\n");
	eprintf(cmdp, "<HTML>\n<HEAD>\n<TITLE>EB-W3 Error</TITLE>\n<HEAD>\n");
	eprintf(cmdp, "<BODY>\n<H1>EB-W3 Error</H1><P><HR><P>\n\n");
	eprintf(cmdp, "%s\n", msg);
	eprintf(cmdp, "</BODY>\n</HTML>\n");
}
